import barrier
import sys
import random

from threading import *


random.seed(0) # genereaza tot timpul aceeasi secventa pseudo-random

class Node(Thread):
    def __init__(self, node_id, b, other_nodes, num_iter):
        Thread.__init__(self)
        self.node_id = node_id
        self.barrier = b
        self.other_nodes = other_nodes
        self.num_iter = num_iter
        self.value = random.randint(1, 1000)
        print self.value
         
    def get_value(self):
        return self.value

    def run(self):
        for it in xrange(self.num_iter):
            indexes = []
            for i in range(3):
                index = random.randint(0, len(self.other_nodes)-1)
                while index in indexes:
                    index = random.randint(0, len(self.other_nodes)-1)
                indexes.append(index)

                neighbour_value = self.other_nodes[index].get_value()
                new_value = self.value
                if self.value > neighbour_value:
                    new_value = neighbour_value
            
            self.barrier.wait()
            self.value = new_value
            print "Thread {}, value {}, cycle {}, indexes{}\n".format(self.node_id, self.value, it, indexes),

if __name__ == "__main__":
    if len(sys.argv) == 2:
        num_threads = int(sys.argv[1])
    else:
        print "Usage: python " + sys.argv[0] + " num_nodes"
        sys.exit(0)
    
    num_iter = 10  # numar iteratii/cicluri algoritm
    
    b = barrier.ReusableBarrierCond(num_threads)
    
    threads = []
    for i in range(num_threads):
        threads.append(Node(i, b, threads, num_iter))

    for node in threads:
        node.start()
    
    for t in threads:
        t.join()
